diff --git a/example/Makefile.am b/example/Makefile.am
index 9503a1baf..695e029c9 100644
--- a/example/Makefile.am
+++ b/example/Makefile.am
@@ -10,3 +10,5 @@ SUBDIRS = classifier \
 	  time \
 	  timer \
 	  traffic_mgmt
+
+noinst_HEADERS = example_debug.h
diff --git a/example/Makefile.inc b/example/Makefile.inc
index cba385b77..12edc46c0 100644
--- a/example/Makefile.inc
+++ b/example/Makefile.inc
@@ -11,4 +11,4 @@ AM_CFLAGS = \
 	-I$(top_srcdir)/platform/@with_platform@/arch/@ARCH_DIR@ \
 	-I$(top_builddir)/include
 
-AM_LDFLAGS = -L$(LIB)
+AM_LDFLAGS = -L$(LIB) -static
diff --git a/example/classifier/Makefile.am b/example/classifier/Makefile.am
index 0c66e145b..a0003e9a4 100644
--- a/example/classifier/Makefile.am
+++ b/example/classifier/Makefile.am
@@ -1,10 +1,5 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_classifier$(EXEEXT)
-odp_classifier_LDFLAGS = $(AM_LDFLAGS) -static
-odp_classifier_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_classifier
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_classifier_SOURCES = odp_classifier.c
+odp_classifier_SOURCES = odp_classifier.c
diff --git a/example/generator/Makefile.am b/example/generator/Makefile.am
index 49a74978a..7deeef406 100644
--- a/example/generator/Makefile.am
+++ b/example/generator/Makefile.am
@@ -1,10 +1,5 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_generator$(EXEEXT)
-odp_generator_LDFLAGS = $(AM_LDFLAGS) -static
-odp_generator_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_generator
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_generator_SOURCES = odp_generator.c
+odp_generator_SOURCES = odp_generator.c
diff --git a/example/hello/Makefile.am b/example/hello/Makefile.am
index 2e4e0cee5..a2d976015 100644
--- a/example/hello/Makefile.am
+++ b/example/hello/Makefile.am
@@ -1,10 +1,8 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_hello$(EXEEXT)
-odp_hello_LDFLAGS = $(AM_LDFLAGS) -static
-odp_hello_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_hello
 
-dist_odp_hello_SOURCES = odp_hello.c
+odp_hello_SOURCES = odp_hello.c
 
 if test_example
 TESTS = odp_hello
diff --git a/example/ipfragreass/Makefile.am b/example/ipfragreass/Makefile.am
index f805a69ba..fa7d5c8bd 100644
--- a/example/ipfragreass/Makefile.am
+++ b/example/ipfragreass/Makefile.am
@@ -1,22 +1,17 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_ipfragreass$(EXEEXT)
-odp_ipfragreass_LDFLAGS = $(AM_LDFLAGS) -static
-odp_ipfragreass_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_ipfragreass
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_atomics.h \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_atomics_arm.h \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_fragment.h \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_helpers.h \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_ip.h \
-		  $(top_srcdir)/example/ipfragreass/odp_ipfragreass_reassemble.h \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_ipfragreass_SOURCES = odp_ipfragreass.c \
-			       odp_ipfragreass_fragment.c \
-			       odp_ipfragreass_helpers.c \
-			       odp_ipfragreass_reassemble.c
+odp_ipfragreass_SOURCES = odp_ipfragreass.c \
+			  odp_ipfragreass_fragment.c \
+			  odp_ipfragreass_helpers.c \
+			  odp_ipfragreass_reassemble.c \
+			  odp_ipfragreass_atomics.h \
+			  odp_ipfragreass_atomics_arm.h \
+			  odp_ipfragreass_fragment.h \
+			  odp_ipfragreass_helpers.h \
+			  odp_ipfragreass_ip.h \
+			  odp_ipfragreass_reassemble.h
 
 if test_example
 TESTS = odp_ipfragreass
diff --git a/example/ipsec/Makefile.am b/example/ipsec/Makefile.am
index fd9b3c722..46613065d 100644
--- a/example/ipsec/Makefile.am
+++ b/example/ipsec/Makefile.am
@@ -2,35 +2,30 @@ include $(top_srcdir)/example/Makefile.inc
 
 AM_CPPFLAGS = $(OPENSSL_CPPFLAGS)
 
-bin_PROGRAMS = odp_ipsec$(EXEEXT)
-odp_ipsec_LDFLAGS = $(AM_LDFLAGS) -static
-odp_ipsec_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
-
-noinst_HEADERS = \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_cache.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_fwd_db.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_loop_db.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_misc.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_sa_db.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_sp_db.h \
-		  $(top_srcdir)/example/ipsec/odp_ipsec_stream.h \
-		  $(top_srcdir)/example/example_debug.h
+bin_PROGRAMS = odp_ipsec
 
 dist_bin_SCRIPTS = \
-		   $(srcdir)/odp_ipsec_run_ah_in \
-		   $(srcdir)/odp_ipsec_run_ah_out \
-		   $(srcdir)/odp_ipsec_run_both_in \
-		   $(srcdir)/odp_ipsec_run_both_out \
-		   $(srcdir)/odp_ipsec_run_esp_in \
-		   $(srcdir)/odp_ipsec_run_esp_out \
-		   $(srcdir)/odp_ipsec_run_live \
-		   $(srcdir)/odp_ipsec_run_router \
-		   $(srcdir)/odp_ipsec_run_simple
+	      odp_ipsec_run_ah_in \
+	      odp_ipsec_run_ah_out \
+	      odp_ipsec_run_both_in \
+	      odp_ipsec_run_both_out \
+	      odp_ipsec_run_esp_in \
+	      odp_ipsec_run_esp_out \
+	      odp_ipsec_run_live \
+	      odp_ipsec_run_router \
+	      odp_ipsec_run_simple
 
-dist_odp_ipsec_SOURCES = odp_ipsec.c \
-			 odp_ipsec_sa_db.c \
-			 odp_ipsec_sp_db.c \
-			 odp_ipsec_fwd_db.c \
-			 odp_ipsec_loop_db.c \
-			 odp_ipsec_cache.c \
-			 odp_ipsec_stream.c
+odp_ipsec_SOURCES = odp_ipsec.c \
+		    odp_ipsec_sa_db.c \
+		    odp_ipsec_sp_db.c \
+		    odp_ipsec_fwd_db.c \
+		    odp_ipsec_loop_db.c \
+		    odp_ipsec_cache.c \
+		    odp_ipsec_stream.c \
+		    odp_ipsec_cache.h \
+		    odp_ipsec_fwd_db.h \
+		    odp_ipsec_loop_db.h \
+		    odp_ipsec_misc.h \
+		    odp_ipsec_sa_db.h \
+		    odp_ipsec_sp_db.h \
+		    odp_ipsec_stream.h
diff --git a/example/l2fwd_simple/Makefile.am b/example/l2fwd_simple/Makefile.am
index fe2065452..f082335ef 100644
--- a/example/l2fwd_simple/Makefile.am
+++ b/example/l2fwd_simple/Makefile.am
@@ -1,13 +1,8 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_l2fwd_simple$(EXEEXT)
-odp_l2fwd_simple_LDFLAGS = $(AM_LDFLAGS) -static
-odp_l2fwd_simple_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_l2fwd_simple
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_l2fwd_simple_SOURCES = odp_l2fwd_simple.c
+odp_l2fwd_simple_SOURCES = odp_l2fwd_simple.c
 
 if test_example
 if HAVE_PCAP
diff --git a/example/l3fwd/Makefile.am b/example/l3fwd/Makefile.am
index 21d0cf1a3..9a48ea173 100644
--- a/example/l3fwd/Makefile.am
+++ b/example/l3fwd/Makefile.am
@@ -1,15 +1,14 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_l3fwd$(EXEEXT)
-odp_l3fwd_LDFLAGS = $(AM_LDFLAGS) -static
-odp_l3fwd_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_l3fwd
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/l3fwd/odp_l3fwd_db.h \
-		  $(top_srcdir)/example/l3fwd/odp_l3fwd_lpm.h \
-		  $(top_srcdir)/example/example_debug.h
+odp_l3fwd_SOURCES = \
+		    odp_l3fwd.c \
+		    odp_l3fwd_db.c \
+		    odp_l3fwd_lpm.c \
+		    odp_l3fwd_db.h \
+		    odp_l3fwd_lpm.h
 
-dist_odp_l3fwd_SOURCES = odp_l3fwd.c odp_l3fwd_db.c odp_l3fwd_lpm.c
 
 if test_example
 if HAVE_PCAP
diff --git a/example/packet/Makefile.am b/example/packet/Makefile.am
index af729b098..228c3506d 100644
--- a/example/packet/Makefile.am
+++ b/example/packet/Makefile.am
@@ -1,13 +1,8 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_pktio$(EXEEXT)
-odp_pktio_LDFLAGS = $(AM_LDFLAGS) -static
-odp_pktio_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_pktio
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_pktio_SOURCES = odp_pktio.c
+odp_pktio_SOURCES = odp_pktio.c
 
 if test_example
 if HAVE_PCAP
diff --git a/example/switch/Makefile.am b/example/switch/Makefile.am
index 4134bcf3d..2fb21bc41 100644
--- a/example/switch/Makefile.am
+++ b/example/switch/Makefile.am
@@ -1,13 +1,8 @@
 include $(top_srcdir)/example/Makefile.inc
 
-bin_PROGRAMS = odp_switch$(EXEEXT)
-odp_switch_LDFLAGS = $(AM_LDFLAGS) -static
-odp_switch_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
+bin_PROGRAMS = odp_switch
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_switch_SOURCES = odp_switch.c
+odp_switch_SOURCES = odp_switch.c
 
 if test_example
 if HAVE_PCAP
diff --git a/example/time/Makefile.am b/example/time/Makefile.am
index c1db37591..464fbfcab 100644
--- a/example/time/Makefile.am
+++ b/example/time/Makefile.am
@@ -1,10 +1,5 @@
 include $(top_srcdir)/example/Makefile.inc
 
 bin_PROGRAMS = odp_time_global$(EXEEXT)
-odp_time_global_LDFLAGS = $(AM_LDFLAGS) -static
-odp_time_global_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
-
-dist_odp_time_global_SOURCES = time_global_test.c
+odp_time_global_SOURCES = time_global_test.c
diff --git a/example/timer/Makefile.am b/example/timer/Makefile.am
index edb8b2ca2..849319723 100644
--- a/example/timer/Makefile.am
+++ b/example/timer/Makefile.am
@@ -2,17 +2,10 @@ include $(top_srcdir)/example/Makefile.inc
 
 bin_PROGRAMS = odp_timer_test$(EXEEXT) \
 		odp_timer_simple$(EXEEXT)
-odp_timer_test_LDFLAGS = $(AM_LDFLAGS) -static
-odp_timer_test_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
-dist_odp_timer_test_SOURCES = odp_timer_test.c
+odp_timer_test_SOURCES = odp_timer_test.c
 
-odp_timer_simple_LDFLAGS = $(AM_LDFLAGS) -static
-odp_timer_simple_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
-dist_odp_timer_simple_SOURCES = odp_timer_simple.c
+odp_timer_simple_SOURCES = odp_timer_simple.c
 
 if test_example
 TESTS = odp_timer_simple
 endif
-
-noinst_HEADERS = \
-		  $(top_srcdir)/example/example_debug.h
diff --git a/example/traffic_mgmt/Makefile.am b/example/traffic_mgmt/Makefile.am
index c8ff79755..09aa03b1a 100644
--- a/example/traffic_mgmt/Makefile.am
+++ b/example/traffic_mgmt/Makefile.am
@@ -1,9 +1,5 @@
 include $(top_srcdir)/example/Makefile.inc
 
 bin_PROGRAMS = odp_traffic_mgmt$(EXEEXT)
-odp_traffic_mgmt_LDFLAGS = $(AM_LDFLAGS) -static
-odp_traffic_mgmt_CFLAGS = $(AM_CFLAGS) -I${top_srcdir}/example
 
-noinst_HEADERS = $(top_srcdir)/example/example_debug.h
-
-dist_odp_traffic_mgmt_SOURCES = odp_traffic_mgmt.c
+odp_traffic_mgmt_SOURCES = odp_traffic_mgmt.c